import java.awt.Point;
import java.io.*;
import java.util.*;

public class doall implements Runnable {
	public int curTest = 1;
	private PrintWriter out;
	private Random r = new Random(566);
	private ArrayList<Point> al = new ArrayList<Point>();
	private ArrayList<Point> temp = new ArrayList<Point>();
	public final static int MAX = 1000000000;
	
	private int random(int low, int high) {
		return low + r.nextInt(high - low + 1);
	}
	
	private void test() {
		normalize();
		try {
			out = new PrintWriter("" + curTest / 10 + curTest % 10);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
		out.println(al.size());
		int s = random(0, al.size() - 1);
		for (int i = 0; i < al.size(); i++) {
			out.println(al.get(s).x + " " + al.get(s).y);
			s = (s + 1) % al.size();
		}
		out.close();
		curTest++;
		al.clear();
		temp.clear();
		x = y = 0;
		dx = 1;
		dy = 0;
	}
	
	private void normalize() {
		boolean change;
		do {
			change = false;
			for (int i = al.size() - 1; i >= 0; i--) {
				if (i >= al.size())
					continue;
				int i1 = (i + al.size() - 1) % al.size();
				int i2 = (i + 1) % al.size();
				if ((al.get(i).x == al.get(i1).x && al.get(i).x == al.get(i2).x) ||
				    (al.get(i).y == al.get(i1).y && al.get(i).y == al.get(i2).y)) {
					change = true;
					al.remove(i);
				}
			}
		} while (change);
		do {
			change = false;
			for (int i = al.size() - 1; i >= 0; i--) {
				if (i >= al.size())
					continue;
				int i1 = (i + 1) % al.size();
				if (al.get(i).equals(al.get(i1))) {
					if (true) throw new RuntimeException("normalization error");
					change = true;
					al.remove(Math.max(i, i1));
					al.remove(Math.min(i, i1));
				}
			}
		} while (change);
	}

	private void add(int x, int y) {
		al.add(new Point(x, y));
	}
	
	private void move(int x, int y) {
		this.x = x;
		this.y = y;
		add(x, y);
	}
	
	int x, y;
	int dx = 1, dy;
	
	private void snake(int dx, int dy, int steps, int step, int shift) {
		int a = 0;
		for (int i = 0; i < steps; i++) {
			x += dx * step;
			y += dy * step;
			add(x + dy * a, y + dx * a);
			if (i == steps - 1) {
				break;
			} else if (i == steps - 2) {
				a = 0;
			} else {
				a = random(-shift, shift);
			}
			add(x + dy * a, y + dx * a);
		}
	}
	
	private void snake(int steps, int step) {
		snake(dx, dy, steps, step, step);
	}
	
	private void snake(int steps, int step, int shift) {
		snake(dx, dy, steps, step, shift);
	}
	
	private void hill(int dx, int dy, int steps, int step, int shift) {
		int a = 0;
		for (int i = 0; i < steps; i++) {
			x += dx * step;
			y += dy * step;
			add(x + dy * a, y + dx * a);
			if (i == steps - 1) {
				break;
			} else if (i < steps / 2 - 1) {
				a -= shift;
			} else {
				a += shift;
			}
			add(x + dy * a, y + dx * a);
		}
	}
	
	private void make(boolean random) {
		for (int i = 0; i < temp.size(); i++) {
			int i1 = (i + 1) % temp.size();
			int x1 = temp.get(i).x;
			int y1 = temp.get(i).y;
			int x2 = temp.get(i1).x;
			int y2 = temp.get(i1).y;
			// TODO
			if (!random || r.nextBoolean()) {
				add(x1, y2);
			} else {
				add(x2, y1);
			}
			add(x2, y2);
		}
	}
	
	private void stairs(int steps, int step) {
		for (int i = 0; i < steps; i++) {
			fw(step);
			left();
			fw(step);
			right();
		}
	}
	
	private void stairs2(int steps, int step) {
		fw(step);
		left();
		for (int i = 0; i < steps; i++) {
			fw(step);
			left();
			fw(step);
			right();
			fw(step);
			right();
			fw(3 * step);
			left();
		}
		fw(step);
		right();
	}
	
	private void spiral(int deep, int side, int d, boolean rev) {
		side += d;
		for (int i = 0; i < deep; i++) {
			fw(side);
			turn(rev);
			fw(side);
			turn(rev);
			side -= 2 * d;
		}
		fw(d);
		turn(rev);
		for (int i = 0; i < deep - 1; i++) {
			fw(side + (i == 0 ? d : 0));
			turn(!rev);
			fw(side);
			turn(!rev);
			side += 2 * d;
		}
	}
	
	private void hairbrush(int bristles, int minb, int maxb, int step, boolean rev) {
		fw(step);
		for (int i = 0; i < bristles; i++) {
			int br = random(minb, maxb);
			turn(rev);
			fw(br);
			turn(!rev);
			fw(step);
			turn(!rev);
			fw(br);
			turn(rev);
			fw(step);
		}
	}
	
	private void hairbrush2(int bristles, int wid, int step, int step1, boolean rev) {
		fw(step);
		for (int i = 0; i < bristles; i++) {
			int br = random(wid / 3, wid);
			turn(rev);
			hairbrush(br / step, 34 * step / 100, 9 * step / 10, step1, rev);
			turn(!rev);
			fw(step / 2);
			turn(!rev);
			hairbrush(br / step, 34 * step / 100, 9 * step / 10, step1, rev);
			turn(rev);
			fw(2 * step);
		}
	}
	
	private void peano(int n, int x, int y, int dx, int dy, int dx2, int dy2) {
		if (n == 1) {
			move(x, y);
			return;
		}
		n /= 2;
		peano(n, x, y, dx2, dy2, dx, dy);
		peano(n, x + dx2 * n, y + dy2 * n, dx, dy, dx2, dy2);
		peano(n, x + dx2 * n + dx * n, y + dy2 * n + dy * n, dx, dy, dx2, dy2);
		peano(n, x + dx * (2 * n - 1) + dx2 * (n - 1), y + dy * (2 * n - 1) + dy2 * (n - 1), -dx2, -dy2, -dx, -dy);
	}
	
	private void peano(int n, int step) {
		peano(n, x, y, step * dx, step * dy, -step * dy, step * dx);
	}
	
	private void fractal(int len, int step, boolean rev) {
		if (len < step) {
			fw(step);
			turn(rev);
			fw(step);
			turn(rev);
			fw(step);
			return;
		}
		int l = (len - 1) / 2;
		fw(len);
		turn(!rev);
		fractal(l, step, rev);
		turn(!rev);
		fractal(l, step, rev);
		turn(!rev);
		fractal(l, step, rev);
		turn(!rev);
		fw(len);
	}
	
	private void temp(double x, double y) {
		temp.add(new Point((int) x, (int) y));
	}
	
	private void toTemp(int a, int b, int c, int d) {
		for (int i = 0; i < al.size(); i++) {
			int i1 = (i + 1) % al.size();
			int x1 = a * al.get(i).x + b * al.get(i).y;
			int y1 = c * al.get(i).x + d * al.get(i).y;
			int x2 = a * al.get(i1).x + b * al.get(i1).y;
			int y2 = c * al.get(i1).x + d * al.get(i1).y;
			temp(2 * x1, 2 * y1);
			temp(x1 + x2, y1 + y2);
		}
		al.clear();
	}
	
	private void left() {
		int dx1 = -dy;
		int dy1 = dx;
		dx = dx1;
		dy = dy1;
	}
	
	private void right() {
		int dx1 = dy;
		int dy1 = -dx;
		dx = dx1;
		dy = dy1;
	}
	
	private void turn(boolean where) {
		if (where)
			left();
		else
			right();
	}
	
	private void fw(int step) {
		move(x + step * dx, y + step * dy);
	}
	
	private int zeroes(int v) {
		int result = 0;
		while (v > 0 && v % 2 == 0) {
			result++;
			v /= 2;
		}
		return result;
	}
	
	public void run() {
		//1  1*1    
		move(-MAX, -MAX);
		move(-MAX + 1, -MAX);
		move(-MAX + 1, -MAX + 1);
		move(-MAX, -MAX + 1);
		test();
		
		//1  
		for (int d = 0; d < 4; d++) {
			fw(1);
			left();
			fw(1);
			right();
			fw(1);
			right();
			fw(1);
			left();
			fw(2);
			left();
		}
		test();
		
		//1      
		for (int d = 0; d < 4; d++) {
			fw(7);
			left();
			fw(1);
			left();
			fw(1);
			right();
			fw(3);
			right();
			fw(3);
			right();
			fw(1);
			left();
			fw(1);
			left();
		}
		test();
		
		//1    
		hill(1, 0, 10, 1, 1);
		hill(0, 1, 10, 1, 1);
		hill(-1, 0, 10, 1, 1);
		hill(0, -1, 10, 1, 1);
		test();
		
		//1   
		int t = 2;
		stairs(t, 2);
		stairs2(t, 2);
		stairs(t, 2);
		snake(10 * t, 1);
		left();
		snake(10 * t, 1);
		left();
		stairs(t, 2);
		stairs2(t, 2);
		stairs(t, 2);
		snake(10 * t, 1);
		left();
		snake(10 * t, 1);
		left();
		test();

//		//1    
//		for (int i = 0; i < 40; i++) {
//			double angle = 2 * Math.PI * (i + 8) / 40;
//			double r = 20 + 12 * Math.sin(2 * Math.PI * i / 10);
//			temp(r * Math.cos(angle), r * Math.sin(angle));
//		}
//		make(true);
//		test();
		
		//2      
		y = -MAX;
		for (int d = 0; d < 4; d++) {
			int a = random(MAX / 3, 2 * MAX / 3);
			int b = random(MAX / 3, 2 * MAX / 3);
			fw(MAX - a);
			left();
			fw(b);
			right();
			fw(a);
			left();
			fw(MAX - b);
		}
		test();
		
		//2     
		spiral(4, 200000, 5000, true);
		fw(201000);
		left();
		spiral(4, 200000, 8000, true);
		fw(199000);
		test();
		
//		//2    
//		for (int i = 0; i < 100; i++) {
//			double angle = 2 * Math.PI * (i + 0) / 100;
//			double r = 1000 + 800 * Math.sin(2 * Math.PI * i / 50);
//			temp(r * Math.cos(angle), r * Math.sin(angle));
//		}
//		make(true);
//		test();
		
		// TODO 
		
		//2    
		for (int i = 0; i < 100; i++) {
			double angle = 2 * Math.PI * (i + 17) / 100;
			double r = 2000 + 800 * Math.sin(2 * Math.PI * i / 20);
			temp(r * Math.cos(angle), r * Math.sin(angle));
		}
		make(true);
		test();
		
		//2    
		for (int d = 0; d < 4; d++) {
			hairbrush(10, MAX / 100, MAX / 10, MAX / 300, false);
			left();
		}
		test();
		
		//2     
		for (int i = 0; i < 90; i++) {
			double r = 566 + 239 * Math.cos(2 * i / 15);
			double angle = 2 * Math.PI * i / 90;
			temp(r * Math.cos(angle), r * Math.sin(angle));
		}
		make(true);
		test();
		
		//3  
		for (int i = 29; i >= 4; i -= 3) {
			stairs(i, 1);
			right();
			stairs(i, 1);
			right();
		}
		left();
		fw(3);
		left();
		stairs(3, 1);
		left();
		for (int i = 8; i <= 27; i += 3) {
			stairs(i, 1);
			left();
			stairs(i, 1);
			left();
		}
		right();
		fw(1);
		Collections.reverse(al);
		test();
		
		//3     
		left();
		for (int i = 0; i < 20; i++) {
			stairs((int) Math.sqrt(20 * 20 - (2 * i - 20) * (2 * i - 20)), 1);
			right();
			fw(3);
			right();
			stairs((int) Math.sqrt(20 * 20 - (2 * i + 1 - 20) * (2 * i + 1 - 20)), 1);
			left();
			fw(1);
			left();
		}
		right(); right();
		fw(4);
		right();
		stairs(8, 1);
		snake(69, 1);
		Collections.reverse(al);
		test();
		
		//3  
		fw(0);
		right();
		fw(1);
		right();
		hairbrush2(10, 100, 3, 1, true);
		right();
		fw(1);
		Collections.reverse(al);
		test();
		
		//4    ,  
		for (int d = 0; d < 4; d++) {
			fw(MAX / 1000);
			peano(1 << 4, MAX / 100 >> 4);
			fw(MAX / 1000);
			right();
		}
		toTemp(1, 3, 3, -1);
		make(true);
		test();
		
//		//4      
//		for (int d = 0; d < 4; d++) {
//			snake(30, 1, 10);
//			peano(32, 1);
//			right();
//		}
//		Collections.reverse(al);
//		test();
		
		//5      7- 
		right();
		peano(1 << 7, 1);
		right();
		fw(1);
		right();
		fw(0);
		peano(1 << 7, 1);
		right();
		fw(1);
		Collections.reverse(al);
		test();
		
//		//6    ,   
//		for (int d = 0; d < 4; d++) {
//			for (int i = 0; i < 10; i++) fw(MAX / 1000);
//			peano(1 << 5, MAX / 100 >> 5);
//			for (int i = 0; i < 10; i++) fw(MAX / 1000);
//			left();
//		}
//		toTemp(1, 3, -3, 1);
//		make(true);
//		test();
		
//		//6  
//		fw(0);
//		left();
//		fw(10);
//		left();
//		hairbrush2(70, 600, 12, 12, false);
//		left();
//		fw(10);
//		test();
		
		//6      
		hairbrush2(10, 300, 200, 200, false);
		left();
		hairbrush2(30, 3000, 200, 200, false);
		left();
		hairbrush2(10, 300, 200, 200, false);
		left();
		hairbrush2(30, 3000, 200, 200, false);
		toTemp(27, -10, 10, 29);
		make(false);
		test();

		//6      1.585
		fw(0);
		fractal(1022, 1, true);
		test();

		//6       
		for (int d = 0; d < 2; d++) {
			for (int i = 1; i < 48000; i++) {
				fw(zeroes(i));
				right();
				fw(zeroes(i));
				left();
			}
			fw(1);
			right();
			for (int i = 50; i < 100; i++) {
				fw(zeroes(i) * 960);
				right();
				fw(zeroes(i) * 960);
				left();
				if (i == 75) {
					snake(15, 1920, 5 * 1920);
				}
			}
			fw(1);
			right();
		}
		Collections.reverse(al);
		test();
		
		//6   
		for (int i = 0; i < 50000; i++) {
			double r = 300000000
			+ 100000000 * Math.cos(20 * Math.PI * i / 50000)
			+ 100000000 * Math.cos(30 * Math.PI * i / 50000);
			double angle = 2 * Math.PI * i / 50000 + 0.1;
			temp(r * Math.cos(angle), r * Math.sin(angle));
		}
		make(false);
		test();
		
		//6 ,   
		for (int i = 0; i < 50000; i++) {
			double r = 300000000
			+ 2000000 * Math.cos(20 * Math.PI * i / 50000)
			+ 1300000 * Math.cos(30 * Math.PI * i / 50000);
			double angle = 2 * Math.PI * i / 50000 + 0.1;
			temp(r * Math.cos(angle), r * Math.sin(angle));
		}
		make(false);
		test();
		
//		hill(1, 0, 3, 1, 1);
//		hill(0, 1, 3, 1, 1);
//		hill(-1, 0, 3, 1, 1);
//		hill(0, -1, 3, 1, 1);
//		test();
	}
	
	public static void main(String[] args) {
		new Thread(new doall()).start();
	}
}
