import java.io.*;
import java.math.*;
import java.util.*;

public class swamp_al {


  static class Point implements Comparable <Point> {
    int x, y;
    Point (int xx, int yy) {
      x = xx;
      y = yy;
    };
    public int compareTo (Point z) {
      if (x < z.x) return -1;
      if (x > z.x) return 1;
      if (y < z.y) return -1;
      if (y > z.y) return 1;
      return 0;
    };
    public String toString () {
      return "(" + x + ", " + y + ")";
    };

  };


  static class Ev implements Comparable <Ev> {
    int x, y;
    boolean io, iv;
    public int compareTo (Ev z) {
      if (x < z.x) return -1;
      if (x > z.x) return 1;
      if (y < z.y) return -1;
      if (y > z.y) return 1;
      if (io && !z.io) return -1;
      if (!io && z.io) return 1;
      return 0;
    };
    Ev (int xx, int yy, boolean iio, boolean iiv) {
      x = xx;
      y = yy;
      io = iio;
      iv = iiv;
    };

    public String toString () {
      return "(" + x + ", " + y + "): " + io + ", " + iv;
    };

  };







  static boolean isVer (int x1, int y1, int x2, int y2) throws Exception {
    if (x1 == x2 && y1 == y2) throw new Exception ("equal successive points not allowed!");
    if (x1 == x2) return true;
    if (y1 == y2) return false;
    throw new Exception ("only horizontal and vertical allowed");
  };


  static ArrayList <Ev> ev;

  static void addSegment (Point p1, Point p2) throws Exception {
    boolean fo = (p1.x < p2.x) || ((p1.x == p2.x) && (p1.y < p2.y));
    boolean isv = isVer (p1.x, p1.y, p2.x, p2.y);
    ev.add (new Ev (p1.x * 2, p1.y * 2, fo, isv));
    int p2x = p2.x * 2;
    int p2y = p2.y * 2;
    if (isv) {
      if (fo) --p2y; else ++p2y;
    } else {
      if (fo) --p2x; else ++p2x;
    }; 
    ev.add (new Ev (p2x, p2y, !fo, isv));
  };

  static int [] nx, pr, vl, vl2;


  static void remove_at (int x) {
    nx[pr[x]] = nx[x];
    pr[nx[x]] = pr[x];
  };


  static void insert_before (int x, int y) {
    nx[y] = x;
    pr[y] = pr[x];
    nx[pr[x]] = y;
    pr[x] = y;
  };


  static void dump_list (int x) throws Exception {
    int y = x;
    //System.out.println (nx[0] + " " + pr[0]);
    do {
      //System.out.print (x + ": " + vl[x] + ", ");
      if (pr[nx[y]] != y) throw new Exception ("list linkage error");
      y = nx[y];
    } while (y != x);
    System.out.println ();
  };





  public static void main (String args []) throws Exception {
    BufferedReader in = new BufferedReader (new FileReader (new File ("swamp.in")));
    PrintWriter out = new PrintWriter ("swamp.out");

    int n = Integer.parseInt (in.readLine ());
    if (n < 4 || n > (int)1e5 || n % 2 != 0) throw new Exception ("invalid n");

    Point [] p = new Point [n];

    for (int i = 0; i < n; i++) {
      StringTokenizer t = new StringTokenizer (in.readLine ());
      int x = Integer.parseInt (t.nextToken ());
      int y = Integer.parseInt (t.nextToken ());
      if (t.hasMoreTokens ()) throw new Exception ("end-of-line expected");
      if (Math.abs (x) > (int)1e9 || Math.abs (y) > (int)1e9) throw new Exception ("invalid x or y");
      p[i] = new Point (x, y);
    };


    if (in.ready ()) throw new Exception ("eof expected");


    BigInteger s = BigInteger.valueOf (((long)p[n - 1].x) * p[0].y - ((long)p[0].x) * p[n - 1].y);
    boolean st = isVer (p[n - 1].x, p[n - 1].y, p[0].x, p[0].y);

    for (int i = 1; i < n; i++) {
      s = s.add (BigInteger.valueOf (((long)p[i - 1].x) * p[i].y - ((long)p[i].x) * p[i - 1].y));
      boolean cst = isVer (p[i - 1].x, p[i - 1].y, p[i].x, p[i].y);
      if (st == cst) throw new Exception ("segment types must interleave");
      st = cst;
    };

    if (s.compareTo (BigInteger.ZERO) <= 0) throw new Exception ("invalid orientation");

    ev = new ArrayList <Ev> ();

    addSegment (p[n - 1], p[0]);
    for (int i = 1; i < n; i++)
      addSegment (p[i - 1], p[i]);

    Collections.sort (ev);

    int lsz = n + 2;

    pr = new int [lsz];
    nx = new int [lsz];
    vl = new int [lsz];

    for (int i = 1; i < lsz; i++) {
      pr[i] = i - 1;
      nx[i] = i + 1;
    };
    pr[1] = lsz - 1;
    nx[lsz - 1] = 1;
    vl[0] = Integer.MAX_VALUE;

    int ff = 1, cp = 0;
    int lx = -Integer.MAX_VALUE;
    boolean iv = false;

    for (Ev e : ev) {
      //System.out.println (e);
      if (lx != e.x) {
        cp = nx[0];
        if (iv) throw new Exception ("bug in program");
      };
      while (vl[cp] < e.y) {
        if (iv) throw new Exception ("vertical-horizontal intersection detected at (" + (e.x / 2) + ", " + (vl[cp] / 2) + ")");
        cp = nx[cp];
      };
      if (e.iv) {
        //System.out.println (".");
        if (iv && vl[cp] == e.y) throw new Exception ("vertical-horizontal intersection detected at (" + (e.x / 2) + ", " + (vl[cp] / 2) + ")");
        if (iv&&e.io) throw new Exception ("vertical-vertical intersection detected at (" + (e.x / 2) + ", " + (e.y / 2) + ")");
        if (!e.io&&!iv) throw new Exception ("bug in program");
        iv = !iv;
        if (iv && vl[cp] == e.y) throw new Exception ("vertical-horizontal intersection detected at (" + (e.x / 2) + ", " + (vl[cp] / 2) + ")");
      } else {
        if (e.io) {
          int nff = nx[ff];
          remove_at (ff);
          if (vl[cp] == e.y) throw new Exception ("horizontal-horizontal intersection detected at (" + (e.x / 2) + ", " + (e.y / 2) + ")");
          vl[ff] = e.y;
          insert_before (cp, ff);
          ff = nff;
          if (iv) throw new Exception ("vertical-horizontal intersection detected at (" + (e.x / 2) + ", " + (e.y / 2) + ")");
        } else {
          if (vl[cp] != e.y) throw new Exception ("bug in program");
          int ncp = nx[cp];
          remove_at (cp);
          insert_before (ff, cp);
          cp = ncp;
        };
      };
      lx = e.x;
      //dump_list (cp);
    };

    Arrays.sort (p);

    LinkedList <Point> out1 = new LinkedList <Point> (), out2 = new LinkedList <Point> ();

    lx = -Integer.MAX_VALUE;

    int cmx = -Integer.MAX_VALUE, cmn = Integer.MAX_VALUE;
    boolean mxc = false, mnc = false;


    for (int i = 0; i < n; i++) {
      if (lx != p[i].x) {
        if (i > 0) {
          if (mnc && out1.size () > 0)
            out1.addLast (new Point (lx, out1.getLast ().y));
          if (mxc && out1.size () > 0)
            out1.addFirst (new Point (lx, out1.getFirst ().y));
          if (mnc) 
            out1.addLast (new Point (lx, cmn));
          if (mxc)
            out1.addFirst (new Point (lx, cmx));
        };
        mnc = false;
        mxc = false;
        lx = p[i].x;
      };
      if (p[i].y > cmx) {
        cmx = p[i].y; mxc = true;
      };
      if (p[i].y < cmn) {
        cmn = p[i].y; mnc = true;
      };
      //System.out.println (out1);
    };
    if (mnc && out1.size () > 0)
      out1.addLast (new Point (lx, out1.getLast ().y));
    if (mxc && out1.size () > 0)
      out1.addFirst (new Point (lx, out1.getFirst ().y));
    if (mnc) 
      out1.addLast (new Point (lx, cmn));
    if (mxc)
      out1.addFirst (new Point (lx, cmx));
    //System.out.println (out1);

    lx = Integer.MAX_VALUE;

    cmx = -Integer.MAX_VALUE;
    cmn = Integer.MAX_VALUE;
    mxc = false; 
    mnc = false;

    for (int i = n - 1; i >= 0; i--) {
      if (lx != p[i].x) {
        if (i > 0) {
          if (mnc && out2.size () > 0)
            out2.addFirst (new Point (lx, out2.getFirst ().y));
          if (mxc && out2.size () > 0)
            out2.addLast (new Point (lx, out2.getLast ().y));
          if (mnc) 
            out2.addFirst (new Point (lx, cmn));
          if (mxc)
            out2.addLast (new Point (lx, cmx));
        };
        mnc = false;
        mxc = false;
        lx = p[i].x;
      };
      if (p[i].y > cmx) {
        cmx = p[i].y; mxc = true;
      };
      if (p[i].y < cmn) {
        cmn = p[i].y; mnc = true;
      };
      //System.out.println (out2);
    };
    if (mnc && out2.size () > 0)
      out2.addFirst (new Point (lx, out2.getFirst ().y));
    if (mxc && out2.size () > 0)
      out2.addLast (new Point (lx, out2.getLast ().y));
    if (mnc) 
      out2.addFirst (new Point (lx, cmn));
    if (mxc)
      out2.addLast (new Point (lx, cmx));

    //System.out.println (out2);

    out1.addAll (out2);

    out.println (out1.size ());
    for (Point z : out1)
      out.println (z.x + " " + z.y);

    out.close ();


  };
};