import java.io.*;
import java.util.*;

public class swamp_md implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	final int inf = 1000000001;
	
	int n;
	int[] x;
	int[] y;
	ArrayList<Integer> ansx = new ArrayList<Integer>();
	ArrayList<Integer> ansy = new ArrayList<Integer>();

	private void solve() throws IOException {
		n = Integer.parseInt(in.readLine());
		x = new int[n];
		y = new int[n];
		for (int i = 0; i < n; i++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			x[i] = Integer.parseInt(st.nextToken());
			y[i] = Integer.parseInt(st.nextToken());
		}
		convexHull(1, 0, 0, 1);
		convexHull(0, 1, -1, 0);
		convexHull(-1, 0, 0, -1);
		convexHull(0, -1, 1, 0);
		out.println(ansx.size());
		for (int i = 0; i < ansx.size(); i++) {
			out.println(ansx.get(i) + " " + ansy.get(i));
		}
	}

	class Point implements Comparable<Point> {
		int x;
		int y;
		int id;
		
		public Point(int x, int y, int id) {
			this.x = x;
			this.y = y;
			this.id = id;
		}

		public int compareTo(Point that) {
			if (x == that.x)
				return y - that.y;
			return x - that.x;
		}
	}
	
	private void convexHull(int ax, int ay, int bx, int by) {
		Point[] p = new Point[n];
		for (int i = 0; i < n; i++) {
			p[i] = new Point(ax * x[i] + ay * y[i], bx * x[i] + by * y[i], i);
		}
		Arrays.sort(p);
		int x = inf;
		int y = -inf;
		for (int i = n - 1; i >= 0; i--) {
			if (p[i].x == x)
				continue;
			x = p[i].x;
			if (p[i].y <= y)
				continue;
			if (y > -inf) {
				ansx.add(by * x - ay * y);
				ansy.add(ax * y - bx * x);
			}
			y = p[i].y;
			ansx.add(by * x - ay * y);
			ansy.add(ax * y - bx * x);
		}
	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new swamp_md()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("swamp.in"));
			out = new PrintWriter("swamp.out");
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
